diff -ruN qmail-1.03-orig/qmail-local.c qmail-1.03-ldap-20060201-orig/qmail-local.c
--- qmail-1.03-orig/qmail-local.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-local.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "env.h"
@@ -29,6 +30,15 @@
 #include "gfrom.h"
 #include "auto_patrn.h"
 
+#include "qmail-ldap.h"
+#include "qldap-errno.h"
+#include "auto_qmail.h"
+#include "scan.h"
+#include "maildir++.h"
+#ifdef AUTOMAILDIRMAKE
+#include "mailmaker.h"
+#endif
+
 void usage() { strerr_die1x(100,"qmail-local: usage: qmail-local [ -nN ] user homedir local dash ext domain sender aliasempty"); }
 
 void temp_nomem() { strerr_die1x(111,"Out of memory. (#4.3.0)"); }
@@ -38,7 +48,7 @@
 void temp_read() { strerr_die3x(111,"Unable to read message: ",error_str(errno),". (#4.3.0)"); }
 void temp_slowlock()
 { strerr_die1x(111,"File has been locked for 30 seconds straight. (#4.3.0)"); }
-void temp_qmail(fn) char *fn;
+void temp_qmail(fn) const char *fn;
 { strerr_die5x(111,"Unable to open ",fn,": ",error_str(errno),". (#4.3.0)"); }
 
 int flagdoit;
@@ -53,6 +63,9 @@
 char *sender;
 char *aliasempty;
 
+/* define the global variables */
+char *quotastring;
+
 stralloc safeext = {0};
 stralloc ufline = {0};
 stralloc rpline = {0};
@@ -63,23 +76,24 @@
 stralloc cmds = {0};
 stralloc messline = {0};
 stralloc foo = {0};
+stralloc qapp = {0};
 
 char buf[1024];
 char outbuf[1024];
 
 /* child process */
-
 char fntmptph[80 + FMT_ULONG * 2];
-char fnnewtph[80 + FMT_ULONG * 2];
+char fnnewtph[83 + FMT_ULONG * 3];
 void tryunlinktmp() { unlink(fntmptph); }
 void sigalrm() { tryunlinktmp(); _exit(3); }
+int msfd = -1; /* global filedescriptor to the quota file */
 
 void maildir_child(dir)
 char *dir;
 {
  unsigned long pid;
- unsigned long time;
- char host[64];
+ unsigned long tnow;
+ char hostname[64];
  char *s;
  int loop;
  struct stat st;
@@ -88,18 +102,22 @@
  substdio ssout;
 
  sig_alarmcatch(sigalrm);
- if (chdir(dir) == -1) { if (error_temp(errno)) _exit(1); _exit(2); }
+ if (chdir(dir) == -1) {
+   if (error_temp(errno)) _exit(1); else _exit(2);
+ }
+
  pid = getpid();
- host[0] = 0;
- gethostname(host,sizeof(host));
+ hostname[0] = 0;
+ gethostname(hostname,sizeof(hostname));
  for (loop = 0;;++loop)
   {
-   time = now();
+   tnow = now();
    s = fntmptph;
    s += fmt_str(s,"tmp/");
-   s += fmt_ulong(s,time); *s++ = '.';
+   s += fmt_ulong(s,tnow); *s++ = '.';
    s += fmt_ulong(s,pid); *s++ = '.';
-   s += fmt_strn(s,host,sizeof(host)); *s++ = 0;
+   s += fmt_strn(s,hostname,sizeof(hostname)); 
+   *s++ = 0;
    if (stat(fntmptph,&st) == -1) if (errno == error_noent) break;
    /* really should never get to this point */
    if (loop == 2) _exit(1);
@@ -112,8 +130,8 @@
  fd = open_excl(fntmptph);
  if (fd == -1) _exit(1);
 
- substdio_fdbuf(&ss,read,0,buf,sizeof(buf));
- substdio_fdbuf(&ssout,write,fd,outbuf,sizeof(outbuf));
+ substdio_fdbuf(&ss,subread,0,buf,sizeof(buf));
+ substdio_fdbuf(&ssout,subwrite,fd,outbuf,sizeof(outbuf));
  if (substdio_put(&ssout,rpline.s,rpline.len) == -1) goto fail;
  if (substdio_put(&ssout,dtline.s,dtline.len) == -1) goto fail;
 
@@ -125,8 +143,21 @@
 
  if (substdio_flush(&ssout) == -1) goto fail;
  if (fsync(fd) == -1) goto fail;
+ if (fstat(fd, &st) == -1) goto fail;
  if (close(fd) == -1) goto fail; /* NFS dorks */
 
+ s = fnnewtph;
+ while( *s ) s++;
+ s += fmt_str(s,",S=");
+ s += fmt_ulong(s,(unsigned long) st.st_size);
+ *s++ = 0;
+
+ if( quotastring && *quotastring ) {
+   /* finally update the quota file "maildirsize" */
+   quota_add(msfd, (unsigned long) st.st_size, 1);
+   close(msfd);
+ }
+  
  if (link(fntmptph,fnnewtph) == -1) goto fail;
    /* if it was error_exist, almost certainly successful; i hate NFS */
  tryunlinktmp(); _exit(0);
@@ -136,12 +167,115 @@
 
 /* end child process */
 
+/* quota handling warning and bounce */
+void quota_bounce(const char *type)
+{
+	strerr_die3x(100, "The users ", type,
+	    " is over the allowed quota (size). (#5.2.2)");
+}
+
+void quota_warning(char *fn)
+{
+ int child;
+ char *(args[3]);
+ int wstat;
+
+ if (!stralloc_copys(&qapp, auto_qmail)) temp_nomem();
+ if (!stralloc_cats(&qapp, "/bin/qmail-quotawarn")) temp_nomem();
+ if (!stralloc_0(&qapp)) temp_nomem();
+
+ if (seek_begin(0) == -1) temp_rewind();
+
+ switch(child = fork())
+  {
+   case -1:
+     temp_fork();
+   case 0:
+     args[0] = qapp.s; args[1] = fn; args[2] = 0;
+     sig_pipedefault();
+     execv(*args,args);
+     _exit(2);
+  }
+
+ wait_pid(&wstat,child);
+ if (wait_crashed(wstat))
+   temp_childcrashed();
+ switch(wait_exitcode(wstat))
+  {
+   case 2:
+     strerr_die5x(111,"Unable to run quotawarn program: ",
+	 qapp.s, ": ",error_str(errno),". (#4.2.2)");
+   case 111: _exit(111);
+   case 0: break;
+   default: _exit(100);
+  }
+
+}
+/* end -- quota handling warning and bounce */
+
 void maildir(fn)
 char *fn;
 {
  int child;
  int wstat;
 
+ /* quota handling maildir */
+ struct stat mailst;
+ int perc;
+ quota_t q;
+ unsigned long mailsize;
+
+#ifdef AUTOMAILDIRMAKE
+ switch (maildir_make(fn)) {
+ case OK:
+   break;
+ case MAILDIR_CORRUPT:
+   strerr_die3x(111,"The maildir '", fn, "' seems to be corrupted. (#4.2.1)");
+ case ERRNO:
+ default:
+   strerr_die3x(111,"Unable to create maildir '", fn, "' (#4.3.0)");
+ }
+#endif
+
+ if (quotastring && *quotastring) {
+   if (fstat(0, &mailst) != 0)
+       strerr_die3x(111,"Can not stat mail for quota: ",
+	   error_str(errno),". (#4.3.0)");
+   mailsize = mailst.st_size;
+   quota_get(&q, quotastring);
+   if (quota_calc(fn, &msfd, &q) == -1) {
+     /* second chance */
+     sleep(3);
+     if (quota_calc(fn, &msfd, &q) == -1) {
+       strerr_die1x(111,
+	   "Temporary race condition while calculating quota. (#4.3.0)");
+     }
+   }
+   /* fd can be -1 when retval = 0 quota_add/rm take care of that */
+   
+   if (quota_check(&q, mailsize, 1, &perc) != 0) { /* 0 if OK */
+     if (quota_recalc(fn, &msfd, &q) == -1) {
+       /* second chance */
+       sleep(3);
+       if (quota_recalc(fn, &msfd, &q) == -1)
+	 strerr_die1x(111,
+	     "Temporary race condition while recalculating quota. (#4.3.0)");
+     }
+     if (quota_check(&q, mailsize, 1, &perc) != 0) {
+       /* bounce mail but drop a warning first */
+       quota_warning(fn);
+       quota_bounce("mailfolder");
+     }
+   }
+   /* fd can be -1 when retval = 0 quota_add/rm take care of that */
+
+   if (perc >= QUOTA_WARNING_LEVEL) 
+     /* drop a warning when mailbox is around 80% full */
+     quota_warning(fn);
+ }
+ 
+ /* end -- quota handling maildir */
+
  if (seek_begin(0) == -1) temp_rewind();
 
  switch(child = fork())
@@ -153,6 +287,8 @@
      _exit(111);
   }
 
+ if (msfd != -1) close(msfd); /* close the maildirsize fd in the parent */
+
  wait_pid(&wstat,child);
  if (wait_crashed(wstat))
    temp_childcrashed();
@@ -176,6 +312,32 @@
  seek_pos pos;
  int flaglocked;
 
+ /* quota handling mbox */
+ struct stat filest, mailst;
+ unsigned long totalsize;
+ quota_t q;
+
+ if( quotastring && *quotastring ) {
+   quota_get(&q, quotastring);
+   if (stat(fn, &filest) == -1) {
+     filest.st_size = 0;        /* size of nonexisting mailfile */
+     if ( errno != error_noent) { /* FALSE if file doesn't exist */
+       strerr_die5x(111,"Unable to quota ", fn, ": ",error_str(errno), ". (#4.3.0)");
+     }
+   }
+   if (fstat(0, &mailst) != 0)
+     strerr_die3x(111,"Unable to quota mail: ",error_str(errno), ". (#4.3.0)");
+   
+   totalsize = (unsigned long) filest.st_size + (unsigned long) mailst.st_size;
+   if (totalsize * 100 / q.quota_size >= QUOTA_WARNING_LEVEL)
+     /* drop a warning when mailbox is around 80% full */
+     quota_warning(fn);
+   if (totalsize > q.quota_size)
+     quota_bounce("mailbox");
+ }
+ 
+ /* end -- quota handling mbox */
+
  if (seek_begin(0) == -1) temp_rewind();
 
  fd = open_append(fn);
@@ -191,8 +353,8 @@
  seek_end(fd);
  pos = seek_cur(fd);
 
- substdio_fdbuf(&ss,read,0,buf,sizeof(buf));
- substdio_fdbuf(&ssout,write,fd,outbuf,sizeof(outbuf));
+ substdio_fdbuf(&ss,subread,0,buf,sizeof(buf));
+ substdio_fdbuf(&ssout,subwrite,fd,outbuf,sizeof(outbuf));
  if (substdio_put(&ssout,ufline.s,ufline.len)) goto writeerrs;
  if (substdio_put(&ssout,rpline.s,rpline.len)) goto writeerrs;
  if (substdio_put(&ssout,dtline.s,dtline.len)) goto writeerrs;
@@ -241,7 +403,8 @@
    case -1:
      temp_fork();
    case 0:
-     args[0] = "/bin/sh"; args[1] = "-c"; args[2] = prog; args[3] = 0;
+     args[0] = (char *)"/bin/sh"; args[1] = (char *)"-c";
+     args[2] = prog; args[3] = 0;
      sig_pipedefault();
      execv(*args,args);
      strerr_die3x(111,"Unable to run /bin/sh: ",error_str(errno),". (#4.3.0)");
@@ -266,16 +429,21 @@
 char **recips;
 {
  struct qmail qqt;
- char *qqx;
+ const char *qqx;
  substdio ss;
  int match;
 
  if (seek_begin(0) == -1) temp_rewind();
- substdio_fdbuf(&ss,read,0,buf,sizeof(buf));
+ substdio_fdbuf(&ss,subread,0,buf,sizeof(buf));
 
  if (qmail_open(&qqt) == -1) temp_fork();
  mailforward_qp = qmail_qp(&qqt);
+
  qmail_put(&qqt,dtline.s,dtline.len);
+
+ if (recips[1])
+   qmail_puts(&qqt,"Precedence: bulk\n");
+
  do
   {
    if (getln(&ss,&messline,&match,'\n') != 0) { qmail_fail(&qqt); break; }
@@ -295,7 +463,7 @@
  substdio ss;
 
  if (seek_begin(0) == -1) temp_rewind();
- substdio_fdbuf(&ss,read,0,buf,sizeof(buf));
+ substdio_fdbuf(&ss,subread,0,buf,sizeof(buf));
  for (;;)
   {
    if (getln(&ss,&messline,&match,'\n') != 0) temp_read();
@@ -316,11 +484,12 @@
    strerr_die3x(111,"Unable to stat home directory: ",error_str(errno),". (#4.3.0)");
  if (st.st_mode & auto_patrn)
    strerr_die1x(111,"Uh-oh: home directory is writable. (#4.7.0)");
- if (st.st_mode & 01000)
+ if (st.st_mode & 01000) {
    if (flagdoit)
      strerr_die1x(111,"Home directory is sticky: user is editing his .qmail file. (#4.2.1)");
    else
      strerr_warn1("Warning: home directory is sticky.",0);
+ }
 }
 
 int qmeox(dashowner)
@@ -380,7 +549,7 @@
 int *fd;
 int *cutable;
 {
-  int i;
+  unsigned int i;
 
   if (!stralloc_copys(&qme,".qmail")) temp_nomem();
   if (!stralloc_cats(&qme,dash)) temp_nomem();
@@ -395,7 +564,8 @@
     return;
   }
 
-  for (i = safeext.len;i >= 0;--i)
+  i = safeext.len;
+  do {
     if (!i || (safeext.s[i - 1] == '-')) {
       if (!stralloc_copys(&qme,".qmail")) temp_nomem();
       if (!stralloc_cats(&qme,dash)) temp_nomem();
@@ -407,6 +577,7 @@
         return;
       }
     }
+  } while (i-- != 0);
 
   *fd = -1;
 }
@@ -437,28 +608,52 @@
 void sayit(type,cmd,len)
 char *type;
 char *cmd;
-int len;
+unsigned int len;
 {
  substdio_puts(subfdoutsmall,type);
  substdio_put(subfdoutsmall,cmd,len);
  substdio_putsflush(subfdoutsmall,"\n");
 }
 
-void main(argc,argv)
+void unescape(char *s)
+{
+  if (!stralloc_copys(&foo, "")) temp_nomem();
+  do {
+    if (s[0] == '\\' && s[1] == ':') s++;
+    else if (s[0] == ':') {
+      if (!stralloc_0(&foo)) temp_nomem();
+      continue;
+    }
+    if (!stralloc_append(&foo, s)) temp_nomem();
+  } while (*s++);
+}
+
+int main(argc,argv)
 int argc;
 char **argv;
 {
  int opt;
- int i;
- int j;
- int k;
+ unsigned int i;
+ unsigned int j;
+ unsigned int k;
  int fd;
- int numforward;
+ unsigned int numforward;
  char **recips;
  datetime_sec starttime;
  int flagforwardonly;
  char *x;
 
+ /* set up the variables for qmail-ldap */
+ unsigned int slen;
+ int qmode;
+ int flagforwardonly2;
+ int flagnoforward;
+ int flagnolocal;
+ int flagnoprog;
+ int allowldapprog;
+ char *s;
+ char *rt;
+
  umask(077);
  sig_pipeignore();
 
@@ -531,7 +726,7 @@
  if (!stralloc_copys(&ufline,"From ")) temp_nomem();
  if (*sender)
   {
-   int len; int i; char ch;
+   unsigned int len; char ch;
 
    len = str_len(sender);
    if (!stralloc_readyplus(&ufline,len)) temp_nomem();
@@ -582,38 +777,168 @@
  if (!stralloc_0(&foo)) temp_nomem();
  if (!env_put2("HOST4",foo.s)) temp_nomem();
 
- flagforwardonly = 0;
- qmesearch(&fd,&flagforwardonly);
- if (fd == -1)
-   if (*dash)
-     strerr_die1x(100,"Sorry, no mailbox here by that name. (#5.1.1)");
-
- if (!stralloc_copys(&ueo,sender)) temp_nomem();
- if (str_diff(sender,""))
-   if (str_diff(sender,"#@[]"))
-     if (qmeox("-owner") == 0)
-      {
-       if (qmeox("-owner-default") == 0)
-	{
-         if (!stralloc_copys(&ueo,local)) temp_nomem();
-         if (!stralloc_cats(&ueo,"-owner-@")) temp_nomem();
-         if (!stralloc_cats(&ueo,host)) temp_nomem();
-         if (!stralloc_cats(&ueo,"-@[]")) temp_nomem();
-	}
-       else
-	{
-         if (!stralloc_copys(&ueo,local)) temp_nomem();
-         if (!stralloc_cats(&ueo,"-owner@")) temp_nomem();
-         if (!stralloc_cats(&ueo,host)) temp_nomem();
-	}
-      }
- if (!stralloc_0(&ueo)) temp_nomem();
- if (!env_put2("NEWSENDER",ueo.s)) temp_nomem();
+ flagforwardonly = 0; flagforwardonly2 = 0; allowldapprog = 0;
+ flagnoforward = 0; flagnolocal = 0; flagnoprog = 0;
 
+ if (env_get(ENV_GROUP)) {
+   if (flagdoit) {
+     ++count_program;
+     if (!stralloc_copys(&foo,"qmail-group ")) temp_nomem();
+     if (*aliasempty == '.' || *aliasempty == '/')
+       if (!stralloc_cats(&foo,aliasempty)) temp_nomem();
+     if (!stralloc_0(&foo)) temp_nomem();
+     mailprogram(foo.s);
+   } else
+     sayit("group delivery","",0);
+   count_print();
+   _exit(0);
+ }
+ /* quota, dotmode and forwarding handling - part 1 */
+ /* setting the quota */
+ if ((quotastring = env_get(ENV_QUOTA) ) && *quotastring) {
+   if (!flagdoit) sayit("quota defined as: ",quotastring,str_len(quotastring));
+ } else {
+   if (!flagdoit) sayit("unlimited quota",quotastring,0 );
+ }
+   
+ qmode = DO_DOT;  /* default is to use standard .qmail */
+ if ((s = env_get(ENV_DOTMODE))) {
+   if (!case_diffs(DOTMODE_LDAPONLY, s)) {
+     if (!flagdoit) sayit("DOTMODE_LDAPONLY ",s,0);
+     qmode = DO_LDAP;
+   } else if (!case_diffs(DOTMODE_LDAPWITHPROG, s)) {
+     if (!flagdoit) sayit("DOTMODE_LDAPWITHPROG ",s,0);
+     qmode = DO_LDAP;
+     allowldapprog = 1;
+   } else if (!case_diffs(DOTMODE_DOTONLY, s)) {
+     if (!flagdoit) sayit("DOTMODE_DOTONLY ",s,0);
+     qmode = DO_DOT;
+   } else if (!case_diffs(DOTMODE_BOTH, s)) {
+     if (!flagdoit) sayit("DOTMODE_BOTH ",s,0);
+     qmode = DO_BOTH;
+     allowldapprog = 1;
+   } else
+     strerr_die3x(100,"Error: Non valid dot-mode found: ", s, ". (#5.3.5)");
+ }
+	   
+ /* prepare the cmds string to hold all the commands from the 
+  * ldap server and the .qmail file */
  if (!stralloc_ready(&cmds,0)) temp_nomem();
  cmds.len = 0;
- if (fd != -1)
-   if (slurpclose(fd,&cmds,256) == -1) temp_nomem();
+ 
+ if (qmode & DO_LDAP) {
+   /* get the infos from the ldap server (environment) */
+   /* setting the NEWSENDER so echo and forward will work */
+   if (!stralloc_copys(&ueo,sender)) temp_nomem();
+   if (!stralloc_0(&ueo)) temp_nomem();
+   if (!env_put2("NEWSENDER",ueo.s)) temp_nomem();
+
+   if ((s = env_get(ENV_MODE))) {
+     unescape(s);
+     s = foo.s;
+     slen = foo.len-1;
+     for(;;) {
+       if (!case_diffs(MODE_FONLY, s)) {
+         if (!flagdoit) sayit("force forward only ",s,0);
+         flagforwardonly2 = 1;
+         flagnolocal = 1;
+         flagnoprog = 1;
+       } else if (!case_diffs(MODE_REPLY, s)) {
+         if(*sender) {
+           if ((rt = env_get(ENV_REPLYTEXT))) {
+	     ++count_forward;
+             if (flagdoit) {
+	       if (!stralloc_copys(&qapp,"qmail-reply ")) temp_nomem();
+	       if (*aliasempty == '.' || *aliasempty == '/')
+	         if (!stralloc_cats(&qapp,aliasempty)) temp_nomem();
+	       if (!stralloc_0(&qapp)) temp_nomem();
+               mailprogram(qapp.s);
+             } else {
+               sayit("reply to ",sender,str_len(sender));
+               sayit("replytext ",rt,str_len(rt));
+             }
+           } else {
+             strerr_warn1("Warning: Reply mode is on but there is no reply text.", 0);
+           }
+         }
+       } else if (!case_diffs(MODE_NOLOCAL, s) || !case_diffs(MODE_NOMBOX, s)) {
+         if (!flagdoit) sayit("no file delivery ",s,0);
+         flagnolocal = 1;
+       } else if (!case_diffs(MODE_NOFORWARD, s)) {
+	 if (!flagdoit) sayit("no mail forwarding ",s,0);
+	 flagnoforward = 1;
+       } else if (!case_diffs(MODE_NOPROG, s)) {
+         if (!flagdoit) sayit("no program delivery ",s,0);
+         flagnoprog = 1;
+       } else if (!case_diffs(MODE_LOCAL, s) ||
+		  !case_diffs(MODE_FORWARD, s) ||
+		  !case_diffs(MODE_PROG, s) ||
+		  !case_diffs(MODE_NOREPLY, s)) {
+	       /* ignore */;
+       } else strerr_warn3("Warning: undefined mail delivery mode: ",
+                     s," (ignored).", 0);
+       j = byte_chr(s,slen,0); if (j++ == slen) break; s += j; slen -= j;
+     }
+   }
+   if (allowldapprog && !flagnoprog && (s = env_get(ENV_PROGRAM))) {
+     unescape(s);
+     s = foo.s;
+     slen = foo.len-1;
+     for (;;) {
+       if (!stralloc_cats(&cmds, "|")) temp_nomem();
+       if (!stralloc_cats(&cmds, s)) temp_nomem();
+       if (!stralloc_cats(&cmds, "\n")) temp_nomem();
+       j = byte_chr(s,slen,0); if (j++ == slen) break; s += j; slen -= j;
+     }
+   }
+   if (!flagnoforward && (s = env_get(ENV_FORWARDS))) {
+     unescape(s);
+     s = foo.s;
+     slen = foo.len-1;
+     for (;;) {
+       if (!stralloc_cats(&cmds, "&")) temp_nomem();
+       if (!stralloc_cats(&cmds, s)) temp_nomem();
+       if (!stralloc_cats(&cmds, "\n")) temp_nomem();
+       j = byte_chr(s,slen,0); if (j++ == slen) break; s += j; slen -= j;
+     }
+   }
+   if (!flagnolocal) {
+     if (!stralloc_cats(&cmds,aliasempty)) temp_nomem();
+     if (!stralloc_cats(&cmds, "\n")) temp_nomem();
+   } 
+   if (!stralloc_cats(&cmds, "#\n")) temp_nomem();
+ } 
+ if (qmode & DO_DOT) { /* start dotqmail */
+   qmesearch(&fd,&flagforwardonly);
+   if (fd == -1)
+     if (*dash)
+       if (qmode == DO_DOT) /* XXX: OK ??? */
+         strerr_die1x(100,"Sorry, no mailbox here by that name. (#5.1.1)");
+
+   if (!stralloc_copys(&ueo,sender)) temp_nomem();
+   if (str_diff(sender,""))
+     if (str_diff(sender,"#@[]"))
+       if (qmeox("-owner") == 0) {
+         if (qmeox("-owner-default") == 0) {
+           if (!stralloc_copys(&ueo,local)) temp_nomem();
+           if (!stralloc_cats(&ueo,"-owner-@")) temp_nomem();
+           if (!stralloc_cats(&ueo,host)) temp_nomem();
+           if (!stralloc_cats(&ueo,"-@[]")) temp_nomem();
+         } else {
+           if (!stralloc_copys(&ueo,local)) temp_nomem();
+           if (!stralloc_cats(&ueo,"-owner@")) temp_nomem();
+           if (!stralloc_cats(&ueo,host)) temp_nomem();
+         }
+       }
+ 
+   if (!stralloc_0(&ueo)) temp_nomem();
+   if (!env_put2("NEWSENDER",ueo.s)) temp_nomem();
+
+   if (fd != -1)
+     if (slurpclose(fd,&cmds,256) == -1) temp_nomem();
+
+ } else if (!qmode & DO_LDAP) /* impossible see dotmode handling */
+   strerr_die1x(100,"Error: No valid delivery mode selected. (#5.3.5)");
 
  if (!cmds.len)
   {
@@ -633,6 +958,8 @@
      i = j + 1;
     }
 
+ if (flagnoforward) numforward = 0;
+ 
  recips = (char **) alloc((numforward + 1) * sizeof(char *));
  if (!recips) temp_nomem();
  numforward = 0;
@@ -645,7 +972,7 @@
     {
      cmds.s[j] = 0;
      k = j;
-     while ((k > i) && (cmds.s[k - 1] == ' ') || (cmds.s[k - 1] == '\t'))
+     while ((k > i) && ((cmds.s[k - 1] == ' ') || (cmds.s[k - 1] == '\t')))
        cmds.s[--k] = 0;
      switch(cmds.s[i])
       {
@@ -656,8 +983,14 @@
          break;
        case '.':
        case '/':
+	 if (flagnolocal) {
+	   if (flagdoit) break;
+	   else { sayit("disabled file delivery ", cmds.s + i, k - i); break; }
+	 }
 	 ++count_file;
 	 if (flagforwardonly) strerr_die1x(111,"Uh-oh: .qmail has file delivery but has x bit set. (#4.7.0)");
+	 if (flagforwardonly2) 
+	   strerr_die1x(111,"Uh-oh: user has file delivery but is not allowed to. (#4.7.0)");
 	 if (cmds.s[k - 1] == '/')
            if (flagdoit) maildir(cmds.s + i);
            else sayit("maildir ",cmds.s + i,k - i);
@@ -666,8 +999,14 @@
            else sayit("mbox ",cmds.s + i,k - i);
          break;
        case '|':
+	 if (flagnoprog) {
+	   if (flagdoit) break;
+	   else { sayit("disabled program ", cmds.s + i, k - i); break; }
+	 }
 	 ++count_program;
 	 if (flagforwardonly) strerr_die1x(111,"Uh-oh: .qmail has prog delivery but has x bit set. (#4.7.0)");
+	 if (flagforwardonly2)
+	   strerr_die1x(111,"Uh-oh: user has prog delivery but is not allowed to. (#4.7.0)");
          if (flagdoit) mailprogram(cmds.s + i + 1);
          else sayit("program ",cmds.s + i + 1,k - i - 1);
          break;
@@ -679,6 +1018,10 @@
          ++i;
        default:
 	 ++count_forward;
+	 if (flagnoforward) {
+	   if (flagdoit) break;
+	   else { sayit("disabled forward ", cmds.s + i, k - i); break; }
+	 }
          if (flagdoit) recips[numforward++] = cmds.s + i;
          else sayit("forward ",cmds.s + i,k - i);
          break;
@@ -687,12 +1030,12 @@
      if (flag99) break;
     }
 
- if (numforward) if (flagdoit)
+ if (numforward) if (flagdoit) if (!flagnoforward)
   {
    recips[numforward] = 0;
    mailforward(recips);
   }
 
  count_print();
- _exit(0);
+ return 0;
 }
